xref: /openbmc/linux/scripts/kconfig/Makefile (revision 93df8a1e)
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6	localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
21xconfig: $(obj)/qconf
22	$< $(silent) $(Kconfig)
23
24gconfig: $(obj)/gconf
25	$< $(silent) $(Kconfig)
26
27menuconfig: $(obj)/mconf
28	$< $(silent) $(Kconfig)
29
30config: $(obj)/conf
31	$< $(silent) --oldaskconfig $(Kconfig)
32
33nconfig: $(obj)/nconf
34	$< $(silent) $(Kconfig)
35
36silentoldconfig: $(obj)/conf
37	$(Q)mkdir -p include/config include/generated
38	$< $(silent) --$@ $(Kconfig)
39
40localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
41	$(Q)mkdir -p include/config include/generated
42	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
43	$(Q)if [ -f .config ]; then 					\
44			cmp -s .tmp.config .config ||			\
45			(mv -f .config .config.old.1;			\
46			 mv -f .tmp.config .config;			\
47			 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
48			 mv -f .config.old.1 .config.old)		\
49	else								\
50			mv -f .tmp.config .config;			\
51			$(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
52	fi
53	$(Q)rm -f .tmp.config
54
55# Create new linux.pot file
56# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
57update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
58	$(Q)$(kecho) "  GEN     config.pot"
59	$(Q)xgettext --default-domain=linux                         \
60	    --add-comments --keyword=_ --keyword=N_                 \
61	    --from-code=UTF-8                                       \
62	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
63	    --directory=$(srctree) --directory=$(objtree)           \
64	    --output $(obj)/config.pot
65	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
66	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
67	    $(srctree)/arch/*/um/Kconfig`;               \
68	    do                                           \
69		$(kecho) "  GEN     $$i";                    \
70		$(obj)/kxgettext $$i                     \
71		     >> $(obj)/config.pot;               \
72	    done )
73	$(Q)$(kecho) "  GEN     linux.pot"
74	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
75	    --output $(obj)/linux.pot
76	$(Q)rm -f $(obj)/config.pot
77
78# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80	alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
82
83$(simple-targets): $(obj)/conf
84	$< $(silent) --$@ $(Kconfig)
85
86PHONY += oldnoconfig savedefconfig defconfig
87
88# oldnoconfig is an alias of olddefconfig, because people already are dependent
89# on its behavior (sets new symbols to their default value but not 'n') with the
90# counter-intuitive name.
91oldnoconfig: olddefconfig
92
93savedefconfig: $(obj)/conf
94	$< $(silent) --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98	$< $(silent) --defconfig $(Kconfig)
99else
100	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102endif
103
104%_defconfig: $(obj)/conf
105	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
108
109%.config: $(obj)/conf
110	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
111	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
112	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
113
114PHONY += kvmconfig
115kvmconfig: kvm_guest.config
116	@:
117
118PHONY += xenconfig
119xenconfig: xen.config
120	@:
121
122PHONY += tinyconfig
123tinyconfig:
124	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
125
126# Help text used by make help
127help:
128	@echo  '  config	  - Update current config utilising a line-oriented program'
129	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
130	@echo  '                    program'
131	@echo  '  menuconfig	  - Update current config utilising a menu based program'
132	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
133	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
134	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
135	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
136	@echo  '  localyesconfig  - Update current config converting local mods to core'
137	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
138	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
139	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
140	@echo  '  allnoconfig	  - New config where all options are answered with no'
141	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
142	@echo  '  allmodconfig	  - New config selecting modules when possible'
143	@echo  '  alldefconfig    - New config with all symbols set to default'
144	@echo  '  randconfig	  - New config with random answer to all options'
145	@echo  '  listnewconfig   - List new options'
146	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their'
147	@echo  '                    default value'
148	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
149	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
150	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
151
152# lxdialog stuff
153check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
154
155# Use recursively expanded variables so we do not call gcc unless
156# we really need to do so. (Do not call gcc as part of make mrproper)
157HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
158                    -DLOCALE
159
160# ===========================================================================
161# Shared Makefile for the various kconfig executables:
162# conf:	  Used for defconfig, oldconfig and related targets
163# nconf:  Used for the nconfig target.
164#         Utilizes ncurses
165# mconf:  Used for the menuconfig target
166#         Utilizes the lxdialog package
167# qconf:  Used for the xconfig target
168#         Based on Qt which needs to be installed to compile it
169# gconf:  Used for the gconfig target
170#         Based on GTK+ which needs to be installed to compile it
171# object files used by all kconfig flavours
172
173lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
174lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
175
176conf-objs	:= conf.o  zconf.tab.o
177mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
178nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
179kxgettext-objs	:= kxgettext.o zconf.tab.o
180qconf-cxxobjs	:= qconf.o
181qconf-objs	:= zconf.tab.o
182gconf-objs	:= gconf.o zconf.tab.o
183
184hostprogs-y := conf nconf mconf kxgettext qconf gconf
185
186clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
187clean-files	+= zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
188clean-files     += config.pot linux.pot
189
190# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
191PHONY += $(obj)/dochecklxdialog
192$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
193$(obj)/dochecklxdialog:
194	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
195
196always := dochecklxdialog
197
198# Add environment specific flags
199HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
200
201# generated files seem to need this to find local include files
202HOSTCFLAGS_zconf.lex.o	:= -I$(src)
203HOSTCFLAGS_zconf.tab.o	:= -I$(src)
204
205LEX_PREFIX_zconf	:= zconf
206YACC_PREFIX_zconf	:= zconf
207
208HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
209HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
210
211HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
212HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
213                          -Wno-missing-prototypes
214
215HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
216
217HOSTLOADLIBES_nconf	= $(shell \
218				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
219				|| pkg-config --libs menu panel ncurses 2>/dev/null \
220				|| echo "-lmenu -lpanel -lncurses"  )
221$(obj)/qconf.o: $(obj)/.tmp_qtcheck
222
223ifeq ($(MAKECMDGOALS),xconfig)
224$(obj)/.tmp_qtcheck: $(src)/Makefile
225-include $(obj)/.tmp_qtcheck
226
227# Qt needs some extra effort...
228$(obj)/.tmp_qtcheck:
229	@set -e; $(kecho) "  CHECK   qt"; dir=""; pkg=""; \
230	if ! pkg-config --exists QtCore 2> /dev/null; then \
231	    echo "* Unable to find the Qt4 tool qmake. Trying to use Qt3"; \
232	    pkg-config --exists qt 2> /dev/null && pkg=qt; \
233	    pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
234	    if [ -n "$$pkg" ]; then \
235	      cflags="\$$(shell pkg-config $$pkg --cflags)"; \
236	      libs="\$$(shell pkg-config $$pkg --libs)"; \
237	      moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
238	      dir="$$(pkg-config $$pkg --variable=prefix)"; \
239	    else \
240	      for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
241	        if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
242	      done; \
243	      if [ -z "$$dir" ]; then \
244	        echo >&2 "*"; \
245	        echo >&2 "* Unable to find any Qt installation. Please make sure that"; \
246	        echo >&2 "* the Qt4 or Qt3 development package is correctly installed and"; \
247	        echo >&2 "* either qmake can be found or install pkg-config or set"; \
248	        echo >&2 "* the QTDIR environment variable to the correct location."; \
249	        echo >&2 "*"; \
250	        false; \
251	      fi; \
252	      libpath=$$dir/lib; lib=qt; osdir=""; \
253	      $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
254	        osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
255	      test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
256	      test -f $$libpath/libqt-mt.so && lib=qt-mt; \
257	      cflags="-I$$dir/include"; \
258	      libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
259	      moc="$$dir/bin/moc"; \
260	    fi; \
261	    if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
262	      echo "*"; \
263	      echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
264	      echo "*"; \
265	      moc="/usr/bin/moc"; \
266	    fi; \
267	else \
268	  cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
269	  libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
270	  moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
271	  [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
272	fi; \
273	echo "KC_QT_CFLAGS=$$cflags" > $@; \
274	echo "KC_QT_LIBS=$$libs" >> $@; \
275	echo "KC_QT_MOC=$$moc" >> $@
276endif
277
278$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
279
280ifeq ($(MAKECMDGOALS),gconfig)
281-include $(obj)/.tmp_gtkcheck
282
283# GTK+ needs some extra effort, too...
284$(obj)/.tmp_gtkcheck:
285	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
286		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
287			touch $@;								\
288		else									\
289			echo >&2 "*"; 							\
290			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
291			echo >&2 "*";							\
292			false;								\
293		fi									\
294	else										\
295		echo >&2 "*"; 								\
296		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
297		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
298		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
299		echo >&2 "*"; 								\
300		false;									\
301	fi
302endif
303
304$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
305
306$(obj)/qconf.o: $(obj)/qconf.moc
307
308quiet_cmd_moc = MOC     $@
309      cmd_moc = $(KC_QT_MOC) -i $< -o $@
310
311$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
312	$(call cmd,moc)
313
314# Extract gconf menu items for i18n support
315$(obj)/gconf.glade.h: $(obj)/gconf.glade
316	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
317	$(obj)/gconf.glade
318